enablePlugins(ScalaJSPlugin)
enablePlugins(ScalaJSBundlerPlugin)
enablePlugins(ScalablyTypedConverterPlugin)
enablePlugins(ShoconPlugin)
// enablePlugins(SbtTwirl)

name := "scalajs-standalone"
scalaVersion := "2.13.2"

// This is an application with a main method
scalaJSUseMainModuleInitializer := true

// mainClass in Compile := Some("Index.scala")

scalacOptions ++= ScalacOptions.flags

libraryDependencies ++= Seq(
  "org.scala-js" %%% "scalajs-dom" % "1.0.0",
  "com.github.japgolly.scalajs-react" %%% "core" % "1.7.0",
  "com.github.japgolly.scalajs-react" %%% "extra" % "1.7.0",
  "com.github.japgolly.scalajs-react" %%% "ext-monocle-cats" % "1.7.0",
  "com.softwaremill.quicklens" %%% "quicklens" % "1.5.0",
  "com.github.julien-truffaut" %%% "monocle-core" % "2.0.4",
  "com.github.julien-truffaut" %%% "monocle-macro" % "2.0.4",
  "org.typelevel" %%% "cats-core" % "2.1.1",
  "org.typelevel" %%% "cats-core" % "2.1.1",
  "org.typelevel" %%% "cats-effect" % "2.1.4",
  "io.monix" %%% "monix" % "3.2.2",
  // "com.github.japgolly.scalajs-react" %%% "test" % "1.7.0",
  "org.akka-js" %%% "shocon" % "1.0.0",
  "com.typesafe.play" %%% "play-json" % "2.9.0"
)
useYarn := true
stFlavour := Flavour.Japgolly
Compile / npmDependencies ++= Seq(
  "react" -> "16.13.1",
  "react-dom" -> "16.13.1",
  "@types/react" -> "16.9.34",
  "@types/react-dom" -> "16.9.6"
)

compile in Compile := (compile in Compile).dependsOn(shoconConcat).value

webpackDevServerExtraArgs in fastOptJS ++= Seq(
  "--content-base",
  (baseDirectory in ThisBuild).value.getAbsolutePath
)
webpackDevServerExtraArgs := Seq("--inline")

webpackBundlingMode := BundlingMode.LibraryOnly()
